#line 1 "A:/Mikroelektronika/mikroC PRO for PIC/JUMBO elettronica PRO/Web Server/Test_WebServer_Mikroc_ESP8266_PIC18_V3/Test_WebServer_Mikroc_ESP8266_PIC18_V1.c"
#line 40 "A:/Mikroelektronika/mikroC PRO for PIC/JUMBO elettronica PRO/Web Server/Test_WebServer_Mikroc_ESP8266_PIC18_V3/Test_WebServer_Mikroc_ESP8266_PIC18_V1.c"
 sbit led1 at LATC0_bit;
 sbit led2 at LATC1_bit;
 sbit led3 at LATC2_bit;
 sbit led4 at LATC3_bit;
 sbit led5 at LATC4_bit;
 sbit led6 at LATC5_bit;

 sbit ana8 at RC6_bit;
 sbit ana9 at RC7_bit;

 sbit but1 at RA0_bit;
 sbit but2 at RA1_bit;
 sbit but3 at RA2_bit;
 sbit but4 at RA3_bit;
 sbit but5 at RA4_bit;
 sbit but6 at RA5_bit;

 sbit LED at LATB4_bit;
 sbit LED_Status at LATB6_bit;

 sbit USART_Tx at RB7_bit;
 sbit USART_Rx at RB5_bit;

 extern const char AT[] = "AT+";
 extern const char AT_CIPSEND[] = "CIPSEND=";

extern void WiFI_Configure();
extern void WiFi3_Init();
extern void esp8266_Send(const char *s);


const OK = 5;
const ERROR = 2;
const NO_CHANGE = 3;
const FAIL = 4;
const READY = 5;
const busy = 6;
const CIPSEND = 7;

 char received_data[46];
 char transfer_data[27];
 char received_data_0[50] ;
 char received_data_1[50] ;
 char received_data_2[50] ;
 char received_data_3[50] ;
 char received_data_4[50] ;

unsigned short i;
unsigned int tmp;
char text[6];

char state;
char response_rcvd;
char responseID, response = 0;
 char buff_13, buff_14, buff_15, buff_16_;
 char buff_17, buff_18, buff_19, buff_20, buff_21, buff_22;
 char old_page;
 unsigned short ajax_response;



 unsigned short get_resp_timeout;

unsigned short up_down;
 char id_temp;
 char id_list;


 typedef struct {
 unsigned on_send : 1;
 unsigned response_IPD : 1;
 unsigned ESP_OK : 1;
 unsigned closed : 1;
 unsigned soft_AP : 1;
 } Flags;
 Flags flag_;

 char gen_buff;
 char number=0;
 char cnt_response;


 void Delay_msec (unsigned int count_delay);
 void Lampe_LED_Status();
#line 1 "a:/mikroelektronika/mikroc pro for pic/jumbo elettronica pro/web server/test_webserver_mikroc_esp8266_pic18_v3/init_pic18f14k22.c"
#line 11 "a:/mikroelektronika/mikroc pro for pic/jumbo elettronica pro/web server/test_webserver_mikroc_esp8266_pic18_v3/init_pic18f14k22.c"
 void Init_PIC() {

 OSCCON = 0b01111000;
 OSCCON2 = 0b00000100;
 OSCTUNE.B6 = 1;


 ANSEL = 0b00000000;
 ANSELH = 0b00000011;

 CM1CON0 = 0x00;
 CM2CON0 = 0x00;

 T1CON = 0;

 T3CON = 0;

 PORTA = 0 ;
 TRISA = 0b11111111;
 WPUB = 0b11111111;

 PORTB = 0 ;
 TRISB = 0b00100000;
 WPUB = 0b11110000;

 TRISC = 0b11000000;
 PORTC = 0 ;
 LATC = 0;

 INTCON2.RABPU = 0;

 UART1_Init(115200);




 }

 void Init_Interrupt () {










 PIR1.RCIF = 0;
 PIE1.RCIE = 1;

 INTCON = 0b11000000 ;

 }
#line 1 "a:/mikroelektronika/mikroc pro for pic/jumbo elettronica pro/web server/test_webserver_mikroc_esp8266_pic18_v3/wifi3_routines.c"
#line 23 "a:/mikroelektronika/mikroc pro for pic/jumbo elettronica pro/web server/test_webserver_mikroc_esp8266_pic18_v3/wifi3_routines.c"
 const char SSID_STA[] = "xxxxxxxxxxxxxxxx";
 const char password_STA[] = "xxxxxxxxxxxxxx";
 const char IP_ADDR_SERVER[] = "192.168.1.104";

 const char AT_CIPAP[] = "CIPAP=";

 const char port80[] = "80";
 const char SSID_AP[] = "JUMBO elettronica";
 const char password_AP[] = "jumbo123";
 const char IP_address[] = "192.168.4.1";
 const char AT[] = "AT+";
 const char ATE0[] = "ATE0";
 const char AT_RST[] = "RST";
 const char AT_CWMODE[] = "CWMODE=2";
 const char AT_CWMODE_2[] = "CWMODE_CUR=";
 const char AT_CIPMUX[] = "CIPMUX=1";
 const char AT_CIFSR[] = "CIFSR";
 const char AT_CWJAP[] = "CWJAP_CUR=";
 const char AT_CWSAP[] = "CWSAP=";
 const char AT_CWQAP[] = "CWQAP";
 const char AT_CIPSTART[] = "CIPSTART=";
 const char AT_CIPSEND[] = "CIPSEND=";
 const char AT_CIPSTATUS[] ="CIPSTATUS";
 const char AT_CIPSERVER[] ="CIPSERVER=1";
 const char AT_CIPSTO[] ="CIPSTO=5";
 const char AT_CWDHCP[] ="CWDHCP_CUR=1,0";
 const char AT_CIPSTA[] ="CIPSTA_CUR=";
 const char AT_RFPOWER[] ="RFPOWER=";
 const char AT_SLEEP[] ="SLEEP=2";
 const char AT_GSLP[] ="GSLP=5000";
 const char AT_RFVDD[] ="RFVDD=3300";
 const char AT_GMR[] = "GMR";
 const char AT_RESTORE[] = "RESTORE";
 const char AT_CIPSTAMAC[] = "CIPSTAMAC_DEF=";
 const char MAC[] = "18:fe:35:98:d3:7b";

 const char AT_UDP[] ="UDP";
 const char AT_TCP[] ="TCP";

 const char ESP_Msg[] = "JUMBO el";

 const char chanel = 6;
 const char enc = 4;
 char ESP_id =0;

extern const OK;
extern const NO_CHANGE;
extern const READY;
extern char Get_Response();




 void UART_Write_Const(const char *packet);



 void Delay_msec (unsigned int count_delay) {
 for (count_delay; count_delay > 0; count_delay --) {
 Delay_ms (1) ;
 asm { clrwdt }
 }
 }



 void Lampe_LED_Status() {
 unsigned short i;

 for (i=1; i<=5; i++) {
 LED_Status = 0;
 Delay_msec(100);
 LED_Status = 1;
 Delay_msec(100);
 }
 }



 void new_line() {

 UART1_Write(0x0D);
 UART1_Write(0x0A);

 get_resp_timeout = 0; LED=1;

 while(Get_Response() != READY && get_resp_timeout <= 100) {

 Delay_msec(100);
 get_resp_timeout ++;
 }


 if (responseID == READY) {
 Delay_msec(100);
 }
 responseID = 0;
 response =0; LED=0;


 }



 void esp8266_Send(const char *string_) {

 while(*string_) {
 UART1_Write(*string_++);
 }
 }



 void WiFi3_Init() {

 Delay_msec(100);

 Delay_msec(100);

 Delay_msec(2000);
 responseID = 0;
 response =0;
 }





 void Ref_Send(char addr) {
 char buff = '0';
 unsigned short j = 0;

 while (buff != ' ' && j <= 25) {
 buff = EEPROM_Read(addr + j);

 if (buff == ' ' || buff == 0x0A || buff == 0x0D) return;
 if (buff == 0xFF) buff = '0';
 UART1_Write(buff);
 j++;
 }

 }



 void IP_ADDR_Send() {
#line 182 "a:/mikroelektronika/mikroc pro for pic/jumbo elettronica pro/web server/test_webserver_mikroc_esp8266_pic18_v3/wifi3_routines.c"
 }



 void WiFi3_CWMODE() {

 esp8266_Send (AT);
 esp8266_Send (AT_CWMODE_2);
 if (flag_.soft_AP) UART1_Write('2');
 else UART1_Write('1');
 new_line();
 }



 void WiFI_Configure() {
#line 206 "a:/mikroelektronika/mikroc pro for pic/jumbo elettronica pro/web server/test_webserver_mikroc_esp8266_pic18_v3/wifi3_routines.c"
 LED_Status = 1;
 esp8266_Send (AT);
 esp8266_Send (AT_RST);
 new_line();
 LED_Status = 0;
 Delay_msec(2000);
#line 224 "a:/mikroelektronika/mikroc pro for pic/jumbo elettronica pro/web server/test_webserver_mikroc_esp8266_pic18_v3/wifi3_routines.c"
 LED_Status = 1;
 esp8266_Send (AT);
 esp8266_Send (AT_CWMODE);
 LED_Status = 0;
 new_line();



 LED_Status = 1;
 esp8266_Send (AT);
 esp8266_Send (AT_CIPMUX);
 LED_Status = 0;
 new_line();



 LED_Status = 1;
 esp8266_Send (AT);
 esp8266_Send (AT_CIPSERVER);
 UART1_Write(',');
 esp8266_Send (port80);
 LED_Status = 0;
 new_line();
#line 282 "a:/mikroelektronika/mikroc pro for pic/jumbo elettronica pro/web server/test_webserver_mikroc_esp8266_pic18_v3/wifi3_routines.c"
 LED_Status = 1;
 esp8266_Send (AT);
 esp8266_Send(AT_CWSAP);
 UART1_Write('"');
 esp8266_Send(SSID_AP);
 UART1_Write('"');
 UART1_Write(',');
 UART1_Write('"');
 esp8266_Send(password_AP);
 UART1_Write('"');
 UART1_Write(',');
 UART1_Write(chanel+48);
 UART1_Write(',');
 UART1_Write(enc+48);
 LED_Status = 0;
 new_line();

 LED_Status = 1;
 esp8266_Send (AT);
 esp8266_Send (AT_CIPAP);
 UART1_Write('"');
 esp8266_Send(IP_address);
 UART1_Write('"');
 LED_Status = 0;
 new_line();




 LED_Status = 1;
 esp8266_Send (AT);
 esp8266_Send (AT_CIPSTO);
 LED_Status = 0;
 new_line();
#line 333 "a:/mikroelektronika/mikroc pro for pic/jumbo elettronica pro/web server/test_webserver_mikroc_esp8266_pic18_v3/wifi3_routines.c"
 }
#line 1 "a:/mikroelektronika/mikroc pro for pic/jumbo elettronica pro/web server/test_webserver_mikroc_esp8266_pic18_v3/esp8266_routine.c"
#line 13 "a:/mikroelektronika/mikroc pro for pic/jumbo elettronica pro/web server/test_webserver_mikroc_esp8266_pic18_v3/esp8266_routine.c"
 extern const char AT[] = "AT+";
 extern const char AT_CIPSEND[] = "CIPSEND=";
 const char AT_CIPCLOSE[] ="CIPCLOSE=";


 extern void Delay_msec (unsigned int count_delay);
 extern unsigned int Calc_Value (unsigned short tilde, unsigned short count);


 unsigned int UART_Length_Write_Const (const char *packet, char mode);
#line 1 "a:/mikroelektronika/mikroc pro for pic/jumbo elettronica pro/web server/test_webserver_mikroc_esp8266_pic18_v3/utility.c"
#line 30 "a:/mikroelektronika/mikroc pro for pic/jumbo elettronica pro/web server/test_webserver_mikroc_esp8266_pic18_v3/utility.c"
const code char *head =
#line 43 "a:/mikroelektronika/mikroc pro for pic/jumbo elettronica pro/web server/test_webserver_mikroc_esp8266_pic18_v3/utility.c"
"<!DOCTYPE html PUBLIC><html><head><title>JUMBO elettronica</title></head><img src=\"xxx\"><BODY bgcolor=#7495a5><h1 align=center style=\"color:red;background:yellow;\">JUMBO elettronica WEB SERVER</h1></head><body bgcolor=#7495a5>";

const char *indexpage =
#line 62 "a:/mikroelektronika/mikroc pro for pic/jumbo elettronica pro/web server/test_webserver_mikroc_esp8266_pic18_v3/utility.c"
"<h1 align=center><font color=blue>HOME</h1><br><table width=\"60%\" align=center bgcolor=yellow border=3><tr><th colspan=2>INPUT ANALOGICI</th></tr><tr><td>AN 0</td><td>~00</td></tr><tr><td>AN 1</td><td>~01</td></tr></table>";

const char *footer =
#line 74 "a:/mikroelektronika/mikroc pro for pic/jumbo elettronica pro/web server/test_webserver_mikroc_esp8266_pic18_v3/utility.c"
"<br><hr color=\"blue\"><br><h5 align=center style=\"color:red;background:yellow;\">Powered by JUMBO elettronica</h5></body></html>\r\n";
#line 91 "a:/mikroelektronika/mikroc pro for pic/jumbo elettronica pro/web server/test_webserver_mikroc_esp8266_pic18_v3/utility.c"
const char *index_test =
#line 154 "a:/mikroelektronika/mikroc pro for pic/jumbo elettronica pro/web server/test_webserver_mikroc_esp8266_pic18_v3/utility.c"
"HTTP/1.1 200 OK\nContent-type:text/html\n\n\"<meta http-equiv=\"refresh\" content=\"3000\"><HTML><HEAD><title>JUMBO elettronica</title></HEAD><BODY><center><img src=\"GI1\"><img src=\"GI2\"><h1 align=center style=\"color:red;background:yellow;\">PIC18F14K22 + ESP8266 Mini Web Server</h1><a href=/>Reload</a><script src=/s></script><table align=center><tr><td valign=top><table border=1 style=\"font-size:20px ;font-family: terminal ;\"><tr><th colspan=2>ADC</th></tr><tr><td>AN8</td><td><script>document.write(AN8)</script></td></tr><tr><td>AN9</td><td><script>document.write(AN9)</script></td></tr></table></td><td><table border=1 style=\"font-size:20px ;font-family: terminal ;\"><tr><th colspan=2>PORTA</th>\</tr><script>var str,i;str=\"\";for(i=0;i<6;i++){str+=\"<tr><td bgcolor=pink>BUTTON #\"+i+\"</td>\";if(PORTA&(1<<i)){str+=\"<td bgcolor=red>ON\";}else {str+=\"<td bgcolor=#cccccc>OFF\";}str+=\"</td></tr>\";}document.write(str) ;</script></table> </td><td><table border=1 style=\"font-size:20px ;font-family: terminal ;\"><tr><th colspan=3>PORTC</th></tr><script>var str,i;str=\"\";for(i=0;i<6;i++){str+=\"<tr><td bgcolor=yellow>LED #\"+i+\"</td>\";if(PORTC&(1<<i)){str+=\"<td bgcolor=red>ON\";}else {str+=\"<td bgcolor=#cccccc>OFF\";}str+=\"</td><td><a href=/t\"+i+\">Toggle</a></td></tr>\";}document.write(str) ;</script></table></td></tr></table><br><hr color=\"blue\"><br><h5 align=center style=\"color:red;background:yellow;\">Powered by JUMBO elettronica</h5><br><img src=\"GI3\"></HTML>";

const code char *risposta =
#line 164 "a:/mikroelektronika/mikroc pro for pic/jumbo elettronica pro/web server/test_webserver_mikroc_esp8266_pic18_v3/utility.c"
"HTTP/1.1 200 OK\nContent-type: text/plain\n\nvar AN8=~10;var AN9=~11;var PORTA=~12;var PORTC=~13;";




const code char *error_page =
#line 180 "a:/mikroelektronika/mikroc pro for pic/jumbo elettronica pro/web server/test_webserver_mikroc_esp8266_pic18_v3/utility.c"
"<HTML><BODY><BODY bgcolor=#7495a5><h1 align=center><font color=red>404 file not found</h1><br><a href=\" \">RETURN TO MAIN PAGE</a></BODY></HTML>\r\n";

const code char *favicon_ =
#line 186 "a:/mikroelektronika/mikroc pro for pic/jumbo elettronica pro/web server/test_webserver_mikroc_esp8266_pic18_v3/utility.c"
"0x47, 0x49, 0x46, 0x38, 0x39, 0x61, 0x19, 0x3b\r\n";

 const unsigned char favicon[79] = {
0x47, 0x49, 0x46, 0x38, 0x39, 0x61, 0x10, 0x00, 0x10, 0x00, 0x70, 0x00, 0x00, 0x2C, 0x00, 0x00,
0x00, 0x00, 0x10, 0x00, 0x10, 0x00, 0x81, 0xEB, 0x09, 0x49, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x02, 0x28, 0x84, 0x8F, 0xA9, 0x8B, 0xE1, 0xE6, 0xA2, 0x9C, 0x70, 0xDA, 0x07,
0xE4, 0xB9, 0x35, 0xE4, 0x67, 0x55, 0x5F, 0x34, 0x62, 0x58, 0x42, 0x7D, 0x25, 0xA7, 0x5E, 0x5A,
0xAB, 0xA5, 0xE4, 0x0C, 0x6E, 0x64, 0xE7, 0x35, 0xEE, 0xBD, 0xF7, 0x7D, 0x01, 0x00, 0x3B
 };

 const unsigned char jumbo_GIF[79] = {
0x47, 0x49, 0x46, 0x38, 0x39, 0x61, 0x10, 0x00, 0x10, 0x00, 0x70, 0x00, 0x00, 0x2C, 0x00, 0x00,
0x00, 0x00, 0x10, 0x00, 0x10, 0x00, 0x81, 0xEB, 0x09, 0x49, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x02, 0x28, 0x84, 0x8F, 0xA9, 0x8B, 0xE1, 0xE6, 0xA2, 0x9C, 0x70, 0xDA, 0x07,
0xE4, 0xB9, 0x35, 0xE4, 0x67, 0x55, 0x5F, 0x34, 0x62, 0x58, 0x42, 0x7D, 0x25, 0xA7, 0x5E, 0x5A,
0xAB, 0xA5, 0xE4, 0x0C, 0x6E, 0x64, 0xE7, 0x35, 0xEE, 0xBD, 0xF7, 0x7D, 0x01, 0x00, 0x3B
 };

const unsigned char dump_stop_GIF[1127] = {
0x47, 0x49, 0x46, 0x38, 0x39, 0x61, 0x19, 0x00, 0x19, 0x00, 0xf7, 0x00, 0x00, 0x00, 0x00, 0x00,
0x80, 0x00, 0x00, 0x00, 0x80, 0x00, 0x80, 0x80, 0x00, 0x00, 0x00, 0x80, 0x80, 0x00, 0x80, 0x00,
0x80, 0x80, 0x80, 0x80, 0x80, 0xc0, 0xc0, 0xc0, 0xff, 0x00, 0x00, 0x00, 0xff, 0x00, 0xff, 0xff,
0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xff, 0x00, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x33, 0x00, 0x00, 0x66, 0x00, 0x00,
0x99, 0x00, 0x00, 0xcc, 0x00, 0x00, 0xff, 0x00, 0x33, 0x00, 0x00, 0x33, 0x33, 0x00, 0x33, 0x66,
0x00, 0x33, 0x99, 0x00, 0x33, 0xcc, 0x00, 0x33, 0xff, 0x00, 0x66, 0x00, 0x00, 0x66, 0x33, 0x00,
0x66, 0x66, 0x00, 0x66, 0x99, 0x00, 0x66, 0xcc, 0x00, 0x66, 0xff, 0x00, 0x99, 0x00, 0x00, 0x99,
0x33, 0x00, 0x99, 0x66, 0x00, 0x99, 0x99, 0x00, 0x99, 0xcc, 0x00, 0x99, 0xff, 0x00, 0xcc, 0x00,
0x00, 0xcc, 0x33, 0x00, 0xcc, 0x66, 0x00, 0xcc, 0x99, 0x00, 0xcc, 0xcc, 0x00, 0xcc, 0xff, 0x00,
0xff, 0x00, 0x00, 0xff, 0x33, 0x00, 0xff, 0x66, 0x00, 0xff, 0x99, 0x00, 0xff, 0xcc, 0x00, 0xff,
0xff, 0x33, 0x00, 0x00, 0x33, 0x00, 0x33, 0x33, 0x00, 0x66, 0x33, 0x00, 0x99, 0x33, 0x00, 0xcc,
0x33, 0x00, 0xff, 0x33, 0x33, 0x00, 0x33, 0x33, 0x33, 0x33, 0x33, 0x66, 0x33, 0x33, 0x99, 0x33,
0x33, 0xcc, 0x33, 0x33, 0xff, 0x33, 0x66, 0x00, 0x33, 0x66, 0x33, 0x33, 0x66, 0x66, 0x33, 0x66,
0x99, 0x33, 0x66, 0xcc, 0x33, 0x66, 0xff, 0x33, 0x99, 0x00, 0x33, 0x99, 0x33, 0x33, 0x99, 0x66,
0x33, 0x99, 0x99, 0x33, 0x99, 0xcc, 0x33, 0x99, 0xff, 0x33, 0xcc, 0x00, 0x33, 0xcc, 0x33, 0x33,
0xcc, 0x66, 0x33, 0xcc, 0x99, 0x33, 0xcc, 0xcc, 0x33, 0xcc, 0xff, 0x33, 0xff, 0x00, 0x33, 0xff,
0x33, 0x33, 0xff, 0x66, 0x33, 0xff, 0x99, 0x33, 0xff, 0xcc, 0x33, 0xff, 0xff, 0x66, 0x00, 0x00,
0x66, 0x00, 0x33, 0x66, 0x00, 0x66, 0x66, 0x00, 0x99, 0x66, 0x00, 0xcc, 0x66, 0x00, 0xff, 0x66,
0x33, 0x00, 0x66, 0x33, 0x33, 0x66, 0x33, 0x66, 0x66, 0x33, 0x99, 0x66, 0x33, 0xcc, 0x66, 0x33,
0xff, 0x66, 0x66, 0x00, 0x66, 0x66, 0x33, 0x66, 0x66, 0x66, 0x66, 0x66, 0x99, 0x66, 0x66, 0xcc,
0x66, 0x66, 0xff, 0x66, 0x99, 0x00, 0x66, 0x99, 0x33, 0x66, 0x99, 0x66, 0x66, 0x99, 0x99, 0x66,
0x99, 0xcc, 0x66, 0x99, 0xff, 0x66, 0xcc, 0x00, 0x66, 0xcc, 0x33, 0x66, 0xcc, 0x66, 0x66, 0xcc,
0x99, 0x66, 0xcc, 0xcc, 0x66, 0xcc, 0xff, 0x66, 0xff, 0x00, 0x66, 0xff, 0x33, 0x66, 0xff, 0x66,
0x66, 0xff, 0x99, 0x66, 0xff, 0xcc, 0x66, 0xff, 0xff, 0x99, 0x00, 0x00, 0x99, 0x00, 0x33, 0x99,
0x00, 0x66, 0x99, 0x00, 0x99, 0x99, 0x00, 0xcc, 0x99, 0x00, 0xff, 0x99, 0x33, 0x00, 0x99, 0x33,
0x33, 0x99, 0x33, 0x66, 0x99, 0x33, 0x99, 0x99, 0x33, 0xcc, 0x99, 0x33, 0xff, 0x99, 0x66, 0x00,
0x99, 0x66, 0x33, 0x99, 0x66, 0x66, 0x99, 0x66, 0x99, 0x99, 0x66, 0xcc, 0x99, 0x66, 0xff, 0x99,
0x99, 0x00, 0x99, 0x99, 0x33, 0x99, 0x99, 0x66, 0x99, 0x99, 0x99, 0x99, 0x99, 0xcc, 0x99, 0x99,
0xff, 0x99, 0xcc, 0x00, 0x99, 0xcc, 0x33, 0x99, 0xcc, 0x66, 0x99, 0xcc, 0x99, 0x99, 0xcc, 0xcc,
0x99, 0xcc, 0xff, 0x99, 0xff, 0x00, 0x99, 0xff, 0x33, 0x99, 0xff, 0x66, 0x99, 0xff, 0x99, 0x99,
0xff, 0xcc, 0x99, 0xff, 0xff, 0xcc, 0x00, 0x00, 0xcc, 0x00, 0x33, 0xcc, 0x00, 0x66, 0xcc, 0x00,
0x99, 0xcc, 0x00, 0xcc, 0xcc, 0x00, 0xff, 0xcc, 0x33, 0x00, 0xcc, 0x33, 0x33, 0xcc, 0x33, 0x66,
0xcc, 0x33, 0x99, 0xcc, 0x33, 0xcc, 0xcc, 0x33, 0xff, 0xcc, 0x66, 0x00, 0xcc, 0x66, 0x33, 0xcc,
0x66, 0x66, 0xcc, 0x66, 0x99, 0xcc, 0x66, 0xcc, 0xcc, 0x66, 0xff, 0xcc, 0x99, 0x00, 0xcc, 0x99,
0x33, 0xcc, 0x99, 0x66, 0xcc, 0x99, 0x99, 0xcc, 0x99, 0xcc, 0xcc, 0x99, 0xff, 0xcc, 0xcc, 0x00,
0xcc, 0xcc, 0x33, 0xcc, 0xcc, 0x66, 0xcc, 0xcc, 0x99, 0xcc, 0xcc, 0xcc, 0xcc, 0xcc, 0xff, 0xcc,
0xff, 0x00, 0xcc, 0xff, 0x33, 0xcc, 0xff, 0x66, 0xcc, 0xff, 0x99, 0xcc, 0xff, 0xcc, 0xcc, 0xff,
0xff, 0xff, 0x00, 0x00, 0xff, 0x00, 0x33, 0xff, 0x00, 0x66, 0xff, 0x00, 0x99, 0xff, 0x00, 0xcc,
0xff, 0x00, 0xff, 0xff, 0x33, 0x00, 0xff, 0x33, 0x33, 0xff, 0x33, 0x66, 0xff, 0x33, 0x99, 0xff,
0x33, 0xcc, 0xff, 0x33, 0xff, 0xff, 0x66, 0x00, 0xff, 0x66, 0x33, 0xff, 0x66, 0x66, 0xff, 0x66,
0x99, 0xff, 0x66, 0xcc, 0xff, 0x66, 0xff, 0xff, 0x99, 0x00, 0xff, 0x99, 0x33, 0xff, 0x99, 0x66,
0xff, 0x99, 0x99, 0xff, 0x99, 0xcc, 0xff, 0x99, 0xff, 0xff, 0xcc, 0x00, 0xff, 0xcc, 0x33, 0xff,
0xcc, 0x66, 0xff, 0xcc, 0x99, 0xff, 0xcc, 0xcc, 0xff, 0xcc, 0xff, 0xff, 0xff, 0x00, 0xff, 0xff,
0x33, 0xff, 0xff, 0x66, 0xff, 0xff, 0x99, 0xff, 0xff, 0xcc, 0xff, 0xff, 0xff, 0x21, 0xf9, 0x04,
0x01, 0x00, 0x00, 0x10, 0x00, 0x2c, 0x00, 0x00, 0x00, 0x00, 0x19, 0x00, 0x19, 0x00, 0x00, 0x08,
0xff, 0x00, 0xff, 0x09, 0x1c, 0x48, 0xb0, 0xa0, 0xc1, 0x83, 0x08, 0x13, 0x2a, 0x44, 0x48, 0xed,
0x5f, 0xc3, 0x85, 0x07, 0xa9, 0xa5, 0x9a, 0xe2, 0xa7, 0x0f, 0xaa, 0x3e, 0x7d, 0xfc, 0x40, 0x1c,
0x28, 0x71, 0x9a, 0x3f, 0x7f, 0xfd, 0xec, 0xf1, 0xb3, 0x27, 0xad, 0x4f, 0xaa, 0x85, 0x1d, 0xa7,
0x80, 0xf4, 0x77, 0x6f, 0xa4, 0xbd, 0x7a, 0xfc, 0xa6, 0xa4, 0x7a, 0x58, 0x90, 0x9a, 0x1f, 0x8a,
0x1e, 0xa7, 0x4c, 0x9b, 0xd6, 0x8f, 0xdf, 0xc8, 0x98, 0xfc, 0x96, 0x9d, 0x24, 0x48, 0x6d, 0xca,
0x14, 0x54, 0xd3, 0x28, 0x2a, 0x6d, 0x86, 0x4a, 0x9a, 0x34, 0x7b, 0xa1, 0x98, 0x45, 0xb3, 0x77,
0x8a, 0x26, 0xb5, 0x3e, 0xfd, 0xa6, 0xf4, 0xeb, 0xe7, 0x47, 0x5a, 0xd2, 0xa4, 0xd2, 0x50, 0xf5,
0x3b, 0x25, 0xf0, 0xa9, 0x3d, 0x8d, 0x02, 0xa7, 0x48, 0xcb, 0xba, 0x56, 0xab, 0x34, 0xa3, 0x61,
0x99, 0x39, 0x45, 0x41, 0xed, 0x94, 0xbd, 0x68, 0x55, 0x05, 0x76, 0xcd, 0xba, 0x75, 0x2f, 0x45,
0x54, 0x15, 0x9d, 0x4e, 0x61, 0x36, 0xed, 0x69, 0xde, 0x7f, 0x5a, 0x63, 0xb6, 0xe5, 0x97, 0x35,
0xe3, 0xb4, 0x89, 0xcc, 0x4e, 0x49, 0x9b, 0x3a, 0xf9, 0xa1, 0xdf, 0xbe, 0x6b, 0x2d, 0xf6, 0xf3,
0x87, 0xaa, 0xb3, 0x5c, 0x97, 0x87, 0xa7, 0x8c, 0x8c, 0x36, 0x75, 0xaa, 0x3d, 0x7b, 0x9b, 0xa7,
0xf5, 0x39, 0xc5, 0x6c, 0xd9, 0xe9, 0xbb, 0x87, 0xfd, 0xec, 0xe3, 0x07, 0xd3, 0x27, 0xea, 0xd4,
0x7e, 0x9a, 0x4a, 0xe3, 0xf7, 0x8f, 0x24, 0xbf, 0x3e, 0x03, 0xa7, 0x44, 0xab, 0x47, 0xdc, 0xe7,
0x56, 0x7f, 0xaa, 0xef, 0x84, 0xb2, 0x43, 0xcc, 0xde, 0xb2, 0xa9, 0x42, 0x07, 0xfa, 0x89, 0x46,
0xdb, 0xf8, 0xe6, 0xad, 0x7d, 0x22, 0x3f, 0x75, 0x59, 0xcf, 0x0f, 0x4d, 0x3f, 0xa7, 0x66, 0xc3,
0x44, 0xbc, 0xde, 0xaf, 0xb3, 0x9d, 0x50, 0xbb, 0x49, 0x76, 0x1f, 0x2a, 0xf0, 0xaa, 0x75, 0x90,
0x7d, 0x9b, 0xa2, 0xfa, 0x59, 0x4f, 0x14, 0xfb, 0x81, 0xa9, 0x4e, 0xf9, 0x84, 0x5f, 0x5e, 0x2d,
0xb3, 0xd3, 0x41, 0xf9, 0x71, 0x1f, 0x47, 0xa9, 0x58, 0x94, 0x51, 0x6e, 0x7f, 0x49, 0x23, 0x57,
0x46, 0x34, 0x45, 0x44, 0xcd, 0x83, 0x10, 0x4a, 0x44, 0x91, 0x77, 0x0d, 0x6e, 0x64, 0xe1, 0x85,
0x18, 0x66, 0x28, 0x50, 0x40, 0x00, 0x3b
 } ;
#line 283 "a:/mikroelektronika/mikroc pro for pic/jumbo elettronica pro/web server/test_webserver_mikroc_esp8266_pic18_v3/utility.c"
const unsigned char dump_good_GIF[998] = {
0x47, 0x49, 0x46, 0x38, 0x39, 0x61, 0x19, 0x00, 0x19, 0x00, 0xf7, 0x00, 0x00, 0x00, 0x00, 0x00,
0x80, 0x00, 0x00, 0x00, 0x80, 0x00, 0x80, 0x80, 0x00, 0x00, 0x00, 0x80, 0x80, 0x00, 0x80, 0x00,
0x80, 0x80, 0x80, 0x80, 0x80, 0xc0, 0xc0, 0xc0, 0xff, 0x00, 0x00, 0x00, 0xff, 0x00, 0xff, 0xff,
0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xff, 0x00, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x33, 0x00, 0x00, 0x66, 0x00, 0x00,
0x99, 0x00, 0x00, 0xcc, 0x00, 0x00, 0xff, 0x00, 0x33, 0x00, 0x00, 0x33, 0x33, 0x00, 0x33, 0x66,
0x00, 0x33, 0x99, 0x00, 0x33, 0xcc, 0x00, 0x33, 0xff, 0x00, 0x66, 0x00, 0x00, 0x66, 0x33, 0x00,
0x66, 0x66, 0x00, 0x66, 0x99, 0x00, 0x66, 0xcc, 0x00, 0x66, 0xff, 0x00, 0x99, 0x00, 0x00, 0x99,
0x33, 0x00, 0x99, 0x66, 0x00, 0x99, 0x99, 0x00, 0x99, 0xcc, 0x00, 0x99, 0xff, 0x00, 0xcc, 0x00,
0x00, 0xcc, 0x33, 0x00, 0xcc, 0x66, 0x00, 0xcc, 0x99, 0x00, 0xcc, 0xcc, 0x00, 0xcc, 0xff, 0x00,
0xff, 0x00, 0x00, 0xff, 0x33, 0x00, 0xff, 0x66, 0x00, 0xff, 0x99, 0x00, 0xff, 0xcc, 0x00, 0xff,
0xff, 0x33, 0x00, 0x00, 0x33, 0x00, 0x33, 0x33, 0x00, 0x66, 0x33, 0x00, 0x99, 0x33, 0x00, 0xcc,
0x33, 0x00, 0xff, 0x33, 0x33, 0x00, 0x33, 0x33, 0x33, 0x33, 0x33, 0x66, 0x33, 0x33, 0x99, 0x33,
0x33, 0xcc, 0x33, 0x33, 0xff, 0x33, 0x66, 0x00, 0x33, 0x66, 0x33, 0x33, 0x66, 0x66, 0x33, 0x66,
0x99, 0x33, 0x66, 0xcc, 0x33, 0x66, 0xff, 0x33, 0x99, 0x00, 0x33, 0x99, 0x33, 0x33, 0x99, 0x66,
0x33, 0x99, 0x99, 0x33, 0x99, 0xcc, 0x33, 0x99, 0xff, 0x33, 0xcc, 0x00, 0x33, 0xcc, 0x33, 0x33,
0xcc, 0x66, 0x33, 0xcc, 0x99, 0x33, 0xcc, 0xcc, 0x33, 0xcc, 0xff, 0x33, 0xff, 0x00, 0x33, 0xff,
0x33, 0x33, 0xff, 0x66, 0x33, 0xff, 0x99, 0x33, 0xff, 0xcc, 0x33, 0xff, 0xff, 0x66, 0x00, 0x00,
0x66, 0x00, 0x33, 0x66, 0x00, 0x66, 0x66, 0x00, 0x99, 0x66, 0x00, 0xcc, 0x66, 0x00, 0xff, 0x66,
0x33, 0x00, 0x66, 0x33, 0x33, 0x66, 0x33, 0x66, 0x66, 0x33, 0x99, 0x66, 0x33, 0xcc, 0x66, 0x33,
0xff, 0x66, 0x66, 0x00, 0x66, 0x66, 0x33, 0x66, 0x66, 0x66, 0x66, 0x66, 0x99, 0x66, 0x66, 0xcc,
0x66, 0x66, 0xff, 0x66, 0x99, 0x00, 0x66, 0x99, 0x33, 0x66, 0x99, 0x66, 0x66, 0x99, 0x99, 0x66,
0x99, 0xcc, 0x66, 0x99, 0xff, 0x66, 0xcc, 0x00, 0x66, 0xcc, 0x33, 0x66, 0xcc, 0x66, 0x66, 0xcc,
0x99, 0x66, 0xcc, 0xcc, 0x66, 0xcc, 0xff, 0x66, 0xff, 0x00, 0x66, 0xff, 0x33, 0x66, 0xff, 0x66,
0x66, 0xff, 0x99, 0x66, 0xff, 0xcc, 0x66, 0xff, 0xff, 0x99, 0x00, 0x00, 0x99, 0x00, 0x33, 0x99,
0x00, 0x66, 0x99, 0x00, 0x99, 0x99, 0x00, 0xcc, 0x99, 0x00, 0xff, 0x99, 0x33, 0x00, 0x99, 0x33,
0x33, 0x99, 0x33, 0x66, 0x99, 0x33, 0x99, 0x99, 0x33, 0xcc, 0x99, 0x33, 0xff, 0x99, 0x66, 0x00,
0x99, 0x66, 0x33, 0x99, 0x66, 0x66, 0x99, 0x66, 0x99, 0x99, 0x66, 0xcc, 0x99, 0x66, 0xff, 0x99,
0x99, 0x00, 0x99, 0x99, 0x33, 0x99, 0x99, 0x66, 0x99, 0x99, 0x99, 0x99, 0x99, 0xcc, 0x99, 0x99,
0xff, 0x99, 0xcc, 0x00, 0x99, 0xcc, 0x33, 0x99, 0xcc, 0x66, 0x99, 0xcc, 0x99, 0x99, 0xcc, 0xcc,
0x99, 0xcc, 0xff, 0x99, 0xff, 0x00, 0x99, 0xff, 0x33, 0x99, 0xff, 0x66, 0x99, 0xff, 0x99, 0x99,
0xff, 0xcc, 0x99, 0xff, 0xff, 0xcc, 0x00, 0x00, 0xcc, 0x00, 0x33, 0xcc, 0x00, 0x66, 0xcc, 0x00,
0x99, 0xcc, 0x00, 0xcc, 0xcc, 0x00, 0xff, 0xcc, 0x33, 0x00, 0xcc, 0x33, 0x33, 0xcc, 0x33, 0x66,
0xcc, 0x33, 0x99, 0xcc, 0x33, 0xcc, 0xcc, 0x33, 0xff, 0xcc, 0x66, 0x00, 0xcc, 0x66, 0x33, 0xcc,
0x66, 0x66, 0xcc, 0x66, 0x99, 0xcc, 0x66, 0xcc, 0xcc, 0x66, 0xff, 0xcc, 0x99, 0x00, 0xcc, 0x99,
0x33, 0xcc, 0x99, 0x66, 0xcc, 0x99, 0x99, 0xcc, 0x99, 0xcc, 0xcc, 0x99, 0xff, 0xcc, 0xcc, 0x00,
0xcc, 0xcc, 0x33, 0xcc, 0xcc, 0x66, 0xcc, 0xcc, 0x99, 0xcc, 0xcc, 0xcc, 0xcc, 0xcc, 0xff, 0xcc,
0xff, 0x00, 0xcc, 0xff, 0x33, 0xcc, 0xff, 0x66, 0xcc, 0xff, 0x99, 0xcc, 0xff, 0xcc, 0xcc, 0xff,
0xff, 0xff, 0x00, 0x00, 0xff, 0x00, 0x33, 0xff, 0x00, 0x66, 0xff, 0x00, 0x99, 0xff, 0x00, 0xcc,
0xff, 0x00, 0xff, 0xff, 0x33, 0x00, 0xff, 0x33, 0x33, 0xff, 0x33, 0x66, 0xff, 0x33, 0x99, 0xff,
0x33, 0xcc, 0xff, 0x33, 0xff, 0xff, 0x66, 0x00, 0xff, 0x66, 0x33, 0xff, 0x66, 0x66, 0xff, 0x66,
0x99, 0xff, 0x66, 0xcc, 0xff, 0x66, 0xff, 0xff, 0x99, 0x00, 0xff, 0x99, 0x33, 0xff, 0x99, 0x66,
0xff, 0x99, 0x99, 0xff, 0x99, 0xcc, 0xff, 0x99, 0xff, 0xff, 0xcc, 0x00, 0xff, 0xcc, 0x33, 0xff,
0xcc, 0x66, 0xff, 0xcc, 0x99, 0xff, 0xcc, 0xcc, 0xff, 0xcc, 0xff, 0xff, 0xff, 0x00, 0xff, 0xff,
0x33, 0xff, 0xff, 0x66, 0xff, 0xff, 0x99, 0xff, 0xff, 0xcc, 0xff, 0xff, 0xff, 0x21, 0xf9, 0x04,
0x01, 0x00, 0x00, 0x10, 0x00, 0x2c, 0x00, 0x00, 0x00, 0x00, 0x19, 0x00, 0x19, 0x00, 0x00, 0x08,
0xc3, 0x00, 0xff, 0x09, 0x1c, 0x48, 0xb0, 0xa0, 0xc1, 0x83, 0x08, 0x13, 0x2a, 0x4c, 0x18, 0xea,
0x4e, 0xc3, 0x85, 0x09, 0xfb, 0x44, 0xdb, 0x57, 0xaf, 0xde, 0x1d, 0x88, 0x07, 0xfb, 0xec, 0xdb,
0x58, 0x2f, 0x14, 0x46, 0x83, 0xa1, 0xea, 0x51, 0xac, 0x67, 0xe7, 0x63, 0xc1, 0x3b, 0x1b, 0xf7,
0x5d, 0x34, 0x49, 0xb0, 0x8f, 0x48, 0x68, 0x7d, 0x16, 0x86, 0xea, 0xd3, 0x70, 0x66, 0x4d, 0x97,
0x1b, 0x63, 0x46, 0x0c, 0x15, 0x6d, 0xd9, 0xb2, 0x89, 0x22, 0xeb, 0x45, 0x03, 0x4a, 0x32, 0x21,
0x4a, 0x91, 0x29, 0x53, 0x22, 0x1d, 0xb9, 0xd2, 0x60, 0x1f, 0x65, 0x14, 0xa3, 0x06, 0x95, 0xba,
0x4f, 0x99, 0x4e, 0x83, 0x77, 0x7e, 0x46, 0x4d, 0xca, 0xb5, 0xde, 0x32, 0x8f, 0x07, 0x1d, 0x82,
0x0a, 0xc5, 0x73, 0xea, 0x54, 0x68, 0xd1, 0x9a, 0x16, 0x0c, 0xe5, 0xf3, 0x54, 0xb4, 0xa5, 0x49,
0x45, 0x46, 0x03, 0x6b, 0xd0, 0x4e, 0x45, 0xaa, 0x66, 0xf7, 0x41, 0x2b, 0x7a, 0x90, 0xed, 0x5d,
0xae, 0x71, 0xe7, 0x32, 0x04, 0xe5, 0xf3, 0x6e, 0x5e, 0x65, 0x16, 0x8d, 0xce, 0x3d, 0xb5, 0x74,
0xe9, 0x5b, 0xb5, 0x4e, 0xa1, 0xe6, 0x7d, 0xab, 0x2c, 0x9a, 0x55, 0x99, 0x6f, 0xcd, 0x0a, 0x15,
0x4a, 0x57, 0x61, 0x9f, 0xac, 0x95, 0x11, 0x2b, 0xab, 0xc9, 0xd2, 0xa1, 0xe9, 0x87, 0x2c, 0x53,
0xab, 0x3e, 0x18, 0x10, 0x00, 0x3b
 } ;


 char mille, cento, dieci, unita;

 char txt [27];
 char tens[5];
 unsigned int cnt;






 void Word_to_str_wout_zeros( char virgola, char segno) {
 unsigned int buffer;
 unsigned short count=0, buff_8;

 buff_8 =cnt >>8;

 if (buff_8.B7) {
 txt[count] = '-';
 cnt &= 0x7FFF;
 count ++;
 }
 buff_8 = 0;

 buffer = cnt / 10000;
 txt[count] = buffer + 0x30;
 if (buffer > 0) {
 count ++;
 buff_8.B6 = 1;
 }
 cnt -= (buffer * 10000);

 buffer = cnt / 1000;
 txt[count] = buffer + 0x30;
 if (buffer > 0 || buff_8.B6) {
 count ++;
 buff_8.B6 = 1;
 }
 cnt -= (buffer * 1000);

 buffer = cnt / 100;
 txt[count] = buffer + 0x30;
 if (buffer > 0 || buff_8.B6) {
 count ++;
 buff_8.B6 = 1;
 }
 cnt -= (buffer * 100);

 buffer = cnt / 10;
 txt[count] = buffer + 0x30;
 if (buffer > 0 || buff_8.B6 || virgola) {
 count ++;
 }
 cnt -= (buffer * 10);

 if (virgola) {
 txt[count] = ',';
 count ++;
 }

 txt[count] = cnt + 0x30;
 count ++;
 txt[count] = 0;

 asm {clrwdt}
 }




 void Word_to_string(unsigned int value) {
 unsigned int buffer;


 mille = value / 1000 ;
 buffer = value - (mille * 1000);
 cento = buffer / 100;
 buffer -= (cento * 100);
 dieci = buffer / 10;
 unita = buffer - (dieci * 10);
 mille +=0x30;
 cento += 0x30;
 dieci += 0x30;
 unita += 0x30; asm {clrwdt}

 if (mille != 0x30) {
 UART1_Write(mille);
 UART1_Write(cento);
 UART1_Write(dieci);
 }
 else if (cento != 0x30) {
 UART1_Write(cento);
 UART1_Write(dieci);
 }
 else if (dieci != 0x30) UART1_Write(dieci);
 UART1_Write(unita);

 }










 unsigned int Calc_Value (unsigned short tilde, unsigned short count) {
 unsigned short cnt_value, temp;
 char buff;

 switch (tilde) {

 case 0: {
 break;
 }
 case 1: { ByteToStr(cnt_response, txt);
 break;
 }

 case 10: {
 cnt = ADC_Read(8);
 Word_to_str_wout_zeros(0,0);
 break;
 }
 case 11: {
 cnt = ADC_Read(9);
 Word_to_str_wout_zeros(0,0);
 break;
 }
 case 12: {
 cnt = PORTA;
 Word_to_str_wout_zeros(0,0);
 break;
 }
 case 13: {
 cnt = PORTC;
 Word_to_str_wout_zeros(0,0);
 break;
 }
 case 14: {
 break;
 }


 case 170: {
 break;
 }


 case 180: {
 break;
 }
#line 527 "a:/mikroelektronika/mikroc pro for pic/jumbo elettronica pro/web server/test_webserver_mikroc_esp8266_pic18_v3/utility.c"
 default : {
 strcpy(txt, "ERROR");
 break;
 }
 }


 cnt_value =0; asm {clrwdt}
 while (txt[cnt_value] && cnt_value <=25) {
 if (count == 0) { UART1_Write(txt[cnt_value]); }
 cnt_value ++;
 }


 return cnt_value;

 }
#line 29 "a:/mikroelektronika/mikroc pro for pic/jumbo elettronica pro/web server/test_webserver_mikroc_esp8266_pic18_v3/esp8266_routine.c"
 void New_Line_Return() {

 UART1_Write(0x0D);
 UART1_Write(0x0A);
 }










 void Send_Web_Page (const char *packet, char ch_id_, char closed) {
 unsigned int buff_word;


 if (flag_.closed) return;

 buff_word = UART_Length_Write_Const (packet, 1);

 reinvia:
 esp8266_Send(AT);
 esp8266_Send(AT_CIPSEND);
 UART1_Write(ch_id_);
 UART1_Write(',');
 Word_to_string(buff_word);
 UART1_Write(0x0D);
 UART1_Write(0x0A);

 get_resp_timeout = 0;
 while(Get_Response() != busy) {
 Delay_msec (20);
 get_resp_timeout ++;
 if ( get_resp_timeout >= 250) {
 goto Close_connection;

 }



 }

 continue_:
 Delay_msec(10);

 UART_Length_Write_Const (packet, 0);

 get_resp_timeout = 0;
 while(Get_Response() != OK && get_resp_timeout <= 250) {
 Delay_msec (20);
 get_resp_timeout ++;
 }

 if (closed == 0) {
 flag_.closed = 0;
 return;
 }
 else flag_.closed = 1;

 Close_connection:
 Delay_msec(10);
 esp8266_Send(AT);
 esp8266_Send(AT_CIPCLOSE);
 UART1_Write(ch_id_);
 UART1_Write(0x0D);
 UART1_Write(0x0A);
 Delay_msec(20);


 }



 unsigned int UART_Length_Write_Const (const char *packet, char mode) {
 unsigned short i=0, cnt_8, tilde, j;
 unsigned int cnt_16=0, cnt_var_tot=0, cnt_var;
 char buf;

 do {
 buf = packet[cnt_16];
 cnt_16 ++;

 if (buf == '~') {
 tilde = ((packet[cnt_16]-0x30)*10) ;
 cnt_16 ++;
 tilde += (packet[cnt_16]-0x30) ;
 cnt_16 ++;
 cnt_var_tot += Calc_Value (tilde, mode);
 cnt_var_tot -= 3;
 }

 else if (mode==0 && buf != '\0') UART1_Write(buf);

 } while (buf);

 cnt_16 --;

 if (mode ==0) {
 New_Line_Return ();

 Delay_msec(10);
 }
 return (cnt_16 + cnt_var_tot);

 }


 void Send_Image (const char *packet, char ch_id_, char closed) {
 unsigned int buff_word, buf=0;


 if (flag_.closed) return;

 if (packet == dump_stop_GIF) buff_word = 1127;
 else if (packet == dump_good_GIF) buff_word = 998;
 else if (packet == jumbo_GIF) buff_word = 79;
 else if (packet == favicon) buff_word = 79;
 else goto Close_connection;


 reinvia:
 esp8266_Send(AT);
 esp8266_Send(AT_CIPSEND);
 UART1_Write(ch_id_);
 UART1_Write(',');
 Word_to_string(buff_word);
 UART1_Write(0x0D);
 UART1_Write(0x0A);

 get_resp_timeout = 0;
 while(Get_Response() != busy) {
 Delay_msec (20);
 get_resp_timeout ++;
 if ( get_resp_timeout >= 250) {
 goto Close_connection;

 }



 }

 continue_:
 Delay_msec(10);


 do {
 UART1_Write(packet[buf]);
 buf ++;
 } while (buf <= buff_word);


 get_resp_timeout = 0;
 while(Get_Response() != OK && get_resp_timeout <= 250) {
 Delay_msec (20);
 get_resp_timeout ++;
 }

 if (closed == 0) {
 flag_.closed = 0;
 return;
 }
 else flag_.closed = 1;

 Close_connection:
 Delay_msec(10);
 esp8266_Send(AT);
 esp8266_Send(AT_CIPCLOSE);
 UART1_Write(ch_id_);
 UART1_Write(0x0D);
 UART1_Write(0x0A);
 Delay_msec(20);


 }
#line 1 "a:/mikroelektronika/mikroc pro for pic/jumbo elettronica pro/web server/test_webserver_mikroc_esp8266_pic18_v3/esp8266_int.c"
#line 24 "a:/mikroelektronika/mikroc pro for pic/jumbo elettronica pro/web server/test_webserver_mikroc_esp8266_pic18_v3/esp8266_int.c"
 void Gest_led () {

 if (received_data_0[2] == '0') led1 = 1;
 else led1 =0;
 if (received_data_1[2] == '1') led2 = 1;
 else led2 =0;
 if (received_data_2[2] == '2') led3 = 1;
 else led3 =0;
 if (received_data_3[2] == '3') led4 = 1;
 else led4 =0;


 }



 void Copy_Response () {
 char ii;

 if (received_data[2] == '0') {
 for (ii=0; ii<=46; ii++) {
 received_data_0[ii] = received_data[ii];
 }
 cnt_response += 1;
 }

 else if (received_data[2] == '1') {
 for (ii=0; ii<=46; ii++) {
 received_data_1[ii] = received_data[ii];
 }
 cnt_response += 1;
 }

 else if (received_data[2] == '2') {
 for (ii=0; ii<=46; ii++) {
 received_data_2[ii] = received_data[ii];
 }
 cnt_response += 1;
 }

 else if (received_data[2] == '3') {
 for (ii=0; ii<=46; ii++) {
 received_data_3[ii] = received_data[ii];
 }
 cnt_response += 1;
 }

 else if (received_data[2] == '4') {
 for (ii=0; ii<=46; ii++) {
 received_data_4[ii] = received_data[ii];
 }
 cnt_response += 1;
 }


 }




 void interrupt(){
 if (RCIF_bit == 1) {
 tmp = UART1_Read();


 switch (state) {
 case 0: {
 response = 0;
 if (tmp == 'O')
 state = 1;
 else if (tmp == 'E')
 state = 10;




 else if (tmp == 'A')
 state = 40;
 else if (tmp == 'r')
 state = 50;
 else if (tmp == '+') {
 state = 100;
 }
 else if (tmp == '>') {
 responseID = busy;
 response_rcvd = 1;
 }
 break;
 }

 case 1: {
 if (tmp == 'K'){
 response = OK;
 state = 2;
 }
 else
 state = 0;
 break;
 }

 case 10: {
 if (tmp == 'R')
 state = 11;
 else
 state = 0;
 break;
 }

 case 11: {
 if (tmp == 'R')
 state = 12;
 else
 state = 0;
 break;
 }

 case 12: {
 if (tmp == 'O')
 state = 13;
 else
 state = 0;
 break;
 }

 case 13: {
 if (tmp == 'R') {
 response = ERROR;
 state = 2;
 }
 else
 state = 0;
 break;
 }
#line 163 "a:/mikroelektronika/mikroc pro for pic/jumbo elettronica pro/web server/test_webserver_mikroc_esp8266_pic18_v3/esp8266_int.c"
 case 40: {
 if (tmp == 'T')
 state = 41;
 else
 state = 0;
 break;
 }

 case 41: {
 if (tmp == '+') {
 state = 42;
 }
 else
 state = 0;
 break;
 }

 case 42: {
 if (tmp == 'C')
 state = 43;
 else
 state = 0;
 break;
 }

 case 43: {
 if (tmp == 'I')
 state = 44;
 else
 state = 0;
 break;
 }

 case 44: {
 if(tmp == 'P') state = 55;
 else if (tmp == 'F') state = 45;
 else state = 0;
 break;
 }

 case 45: {
 if (tmp == 'S')
 state = 46;
 else
 state = 0;
 break;
 }

 case 46: {
 if (tmp == 'R')
 state = 47;
 else
 state = 0;
 break;
 }

 case 47: {
 if (tmp == 10) {
 state = 48;
 i = 0;
 }
 else if (tmp == 13){

 }
 else
 state = 0;
 break;
 }

 case 48: {
 if (tmp == 13){
 state = 3;
 response = OK;
 }
 else {


 }
 break;
 }


 case 50: {
 if (tmp == 'e')
 state = 51;
 else
 state = 0;
 break;
 }

 case 51: {
 if (tmp == 'a')
 state = 52;
 else
 state = 0;
 break;
 }

 case 52: {
 if (tmp == 'd')
 state = 53;
 else
 state = 0;
 break;
 }

 case 53: {
 if (tmp == 'y') {
 response = READY;
 state = 2;
 }
 else
 state = 0;
 break;
 }


 case 55: {
 if (tmp == 'S')
 state = 56;
 else
 state = 0;
 break;
 }
 case 56: {
 if (tmp == 'E')
 state = 57;
 else
 state = 0;
 break;
 }
 case 57: {
 if (tmp == 'N')
 state = 58;
 else
 state = 0;
 break;
 }
 case 58: {
 if (tmp == 'D')
 state = 59;

 else
 state = 0;
 break;
 }
 case 59: {
 if (tmp == '=')
 state = 60;
 else
 state = 0;
 break;
 }
 case 60: {
 if (tmp == 'N'){

 response = CIPSEND;


 id_temp = tmp;
 state = 0;
 }
 else
 state = 0;
 break;
 }



 case 100 : {
 if(tmp == 'I'){
 i = 0;
 state = 101;
 }
 else {
 state = 0;
 i = 0;
 }
 break;
 }
 case 101 : {
 if(tmp == 'P'){
 i = 0;
 state = 102;
 }
 else {
 state = 0;
 i = 0;
 }
 break;
 }
 case 102 : {
 if(tmp == 'D'){
 received_data[i] = tmp;
 i++;
 state = 103;
 }
 else {
 state = 0;
 i = 0;
 }
 break;
 }
 case 103 : {
 state = 103;
 received_data[i] = tmp;
 i++;
 if (i >= 44) {
 received_data[i+1] = 0;
 i = 0;
 state = 0;
 Copy_response();
 }
 break;
 }


 case 2: {
 if (tmp == 13)
 state = 3;
 else
 state = 0;
 break;
 }
 case 3: {
 if (tmp == 10){
 response_rcvd = 1;
 responseID = response;
 }
 state = 0;
 break;
 }
 default: {
 state = 0;
 break;
 }
 }
 RCIF_bit = 0;
 }
#line 413 "a:/mikroelektronika/mikroc pro for pic/jumbo elettronica pro/web server/test_webserver_mikroc_esp8266_pic18_v3/esp8266_int.c"
 }



char Get_Response() {
 if (response_rcvd) {
 response_rcvd = 0;
 return responseID;
 }
 else
 return 0;
}






 void Configure_Access () {
 char buff = 0;
 unsigned short j = 0, cen, dec, uni, cnt_byte = 0, cnt_cifre =0, IP_addr;

 if (buff_15 == '1') {
 while (buff != ' ' && j <= 25) {
 buff = transfer_data[j+1];

 if (buff == 0x0A || buff == 0x0D) buff = ' ';
 EEPROM_Write(0x10 + j, buff);
 j++;
 }
 }

 else if (buff_15 == '2') {
 while (buff != ' ' && j <= 25) {
 buff = transfer_data[j+1];

 if (buff == 0x0A || buff == 0x0D) buff = ' ';
 EEPROM_Write(0x30 + j, buff);
 j++;
 }
 }

 else if (buff_15 == '3') {
 while (buff != ' ') {
 buff = transfer_data[j];
 j ++;
 if (buff == '.' || buff == ' ') {
 IP_addr = 0;
 if (cnt_cifre == 1){
 IP_addr = cen;

 }
 if (cnt_cifre == 2){
 IP_addr = cen * 10;
 IP_addr += dec;

 }
 if (cnt_cifre == 3){
 IP_addr = cen * 100;
 IP_addr += dec * 10;
 IP_addr += uni;

 }
 cnt_cifre = 0;
 cnt_byte ++;
 }
 else if (buff >= '0' && buff <= '9'){
 if (cnt_cifre == 0) cen = buff - 0x30;
 if (cnt_cifre == 1) dec = buff - 0x30;
 if (cnt_cifre == 2) uni = buff - 0x30;
 cnt_cifre ++;
 }
 }
 }

 }




 void Cnl_Output () {
 unsigned short buff;

 buff = (buff_14-0x30);


 switch (buff) {
 case 0: { led1 ^= 1;
 break;
 }
 case 1: {led2 ^= 1;
 break;
 }
 case 2: {led3 ^= 1;
 break;
 }

 case 3: {led4 ^= 1;
 break;
 }
 case 4: {led5 ^= 1;
 break;
 }
 case 5: {led6 ^= 1;
 break;
 }

 default: {
 break;
 }
 }
 }



 void Put_Response() {
 char ch_id;
 unsigned short get_resp_timeout, j;



 if (received_data_0[2] == '0') {
 flag_.response_IPD = 0;
 buff_13 = received_data_0[13];
 buff_14 = received_data_0[14];
 buff_15 = received_data_0[15];
 buff_16_ = received_data_0[16];
 ch_id = received_data_0[2];
 received_data_0[2] = 0xFF;

 buff_17 = received_data_0[17];
 buff_18 = received_data_0[18];
 buff_19 = received_data_0[19];
 buff_20 = received_data_0[20];
 buff_21 = received_data_0[21];
 buff_22 = received_data_0[22];

 for (j = 18; j<=43;j++) {
 transfer_data[j-18] = received_data_0[j];
 }
 }

 else if (received_data_1[2] == '1') {
 flag_.response_IPD = 0;
 buff_13 = received_data_1[13];
 buff_14 = received_data_1[14];
 buff_15 = received_data_1[15];
 buff_16_ = received_data_1[16];
 ch_id = received_data_1[2];
 received_data_1[2] = 0xFF;

 buff_17 = received_data_1[17];
 buff_18 = received_data_1[18];
 buff_19 = received_data_1[19];
 buff_20 = received_data_1[20];
 buff_21 = received_data_1[21];
 buff_22 = received_data_1[22];

 for (j = 18; j<=43;j++) {
 transfer_data[j-18] = received_data_1[j];
 }
 }

 else if (received_data_2[2] == '2') {
 flag_.response_IPD = 0;
 buff_13 = received_data_2[13];
 buff_14 = received_data_2[14];
 buff_15 = received_data_2[15];
 buff_16_ = received_data_2[16];
 ch_id = received_data_2[2];
 received_data_2[2] = 0xFF;

 buff_17 = received_data_2[17];
 buff_18 = received_data_2[18];
 buff_19 = received_data_2[19];
 buff_20 = received_data_2[20];
 buff_21 = received_data_2[21];
 buff_22 = received_data_2[22];

 for (j = 18; j<=43;j++) {
 transfer_data[j-18] = received_data_2[j];
 }
 }

 else if (received_data_3[2] == '3') {
 flag_.response_IPD = 0;
 buff_13 = received_data_3[13];
 buff_14 = received_data_3[14];
 buff_15 = received_data_3[15];
 buff_16_ = received_data_3[16];
 ch_id = received_data_3[2];
 received_data_3[2] = 0xFF;

 buff_17 = received_data_3[17];
 buff_18 = received_data_3[18];
 buff_19 = received_data_3[19];
 buff_20 = received_data_3[20];
 buff_21 = received_data_3[21];
 buff_22 = received_data_3[22];

 for (j = 18; j<=43;j++) {
 transfer_data[j-18] = received_data_3[j];
 }
 }

 else if (received_data_4[2] == '4') {
 flag_.response_IPD = 0;
 buff_13 = received_data_4[13];
 buff_14 = received_data_4[14];
 buff_15 = received_data_4[15];
 buff_16_ = received_data_4[16];
 ch_id = received_data_4[2];
 received_data_4[2] = 0xFF;

 buff_17 = received_data_4[17];
 buff_18 = received_data_4[18];
 buff_19 = received_data_4[19];
 buff_20 = received_data_4[20];
 buff_21 = received_data_4[21];
 buff_22 = received_data_4[22];

 for (j = 18; j<=43;j++) {
 transfer_data[j-18] = received_data_4[j];
 }
 }










 if (buff_13 == 't') {
 Cnl_Output ();
 buff_13 = 't';
 buff_14 = old_page;
 }
#line 660 "a:/mikroelektronika/mikroc pro for pic/jumbo elettronica pro/web server/test_webserver_mikroc_esp8266_pic18_v3/esp8266_int.c"
 if (buff_13 == 'c' && buff_14 == 'o') {
 Configure_Access ();
 buff_13 = 'p';
 buff_14 = old_page;
 }








 flag_.closed = 0;
#line 681 "a:/mikroelektronika/mikroc pro for pic/jumbo elettronica pro/web server/test_webserver_mikroc_esp8266_pic18_v3/esp8266_int.c"
 LED_Status = 1;

 if(buff_13==' ' || buff_13=='t') {
 Send_Web_Page (index_test, ch_id, 1);
 old_page = buff_14;
 }


 else if(buff_13=='f' && buff_14=='a') {
 Send_Image (favicon, ch_id, 1);

 old_page = buff_14;
 }

 else if(buff_13=='s') {

 Send_Web_Page (risposta, ch_id, 1);
 old_page = buff_14;
 }
 else if(buff_13=='G' && buff_14=='I' && buff_15=='1') {

 Send_Image (dump_stop_GIF, ch_id, 1);
 old_page = buff_14;
 }
 else if(buff_13=='G' && buff_14=='I' && buff_15=='2') {

 Send_Image (dump_good_GIF, ch_id, 1);
 old_page = buff_14;
 }
 else if(buff_13=='G' && buff_14=='I' && buff_15=='3') {

 Send_Image (jumbo_GIF, ch_id, 1);
 old_page = buff_14;
 }
 else if(buff_13=='P' && buff_14=='U') {

 Send_Image (dump_good_GIF, ch_id, 1);
 old_page = buff_14;
 }

 else {
 Send_Web_Page (error_page, ch_id, 1);
 old_page = buff_14;
 }


 LED_Status = 0;


 }
#line 133 "A:/Mikroelektronika/mikroC PRO for PIC/JUMBO elettronica PRO/Web Server/Test_WebServer_Mikroc_ESP8266_PIC18_V3/Test_WebServer_Mikroc_ESP8266_PIC18_V1.c"
 void Delay_msec_ (unsigned short count_delay) {
 unsigned short i;
 for (i=count_delay; i > 0; i --) {
 Delay_ms (1);
 }
 }



 void UART_NewLine () {


 }



 void ByteToString (unsigned short value) {
 short buff;

 buff = value / 100;
 if (buff == 0) UART1_Write(' ');
 else UART1_Write(buff+0x30);
 value -= (buff*100);
 buff = value / 10;
 UART1_Write(buff+0x30);

 value -= (buff*10);
 UART1_Write(value+0x30);

 UART_NewLine ();
 }



 void main() {
 int temp ;
 unsigned short count_LED, count, buf_1, buf_2;
 unsigned short tempor;

 Init_PIC ();
 WiFi3_Init();
 Init_Interrupt ();
 flag_.soft_AP = 1;
 WiFI_Configure();
 state = 0;
 i = 0;
 old_page = '0';
 ADC_Init();

 flag_.response_IPD=0;
 cnt_response = 0;

 received_data_0[2] = 0xFF;
 received_data_1[2] = 0xFF;
 received_data_2[2] = 0xFF;
 received_data_3[2] = 0xFF;
 received_data_4[2] = 0xFF;


 while (1) {
 temp++;
 if (temp >=50000) {
 LED ^= 1;
 temp = 0;
 }


 if (cnt_response > 0) {
 cnt_response -= 1;
 if (cnt_response >= 250) {
 cnt_response = 0;
 }
 else Put_Response();
 }


 }


 }
