/*

                 WiFi_Routine.c      // V.2.2 20/05/2017
                                 
                                     CntBatt_18F14K50 V.1.1 23/06/2018
                                     01/09/2018: Aggiornamento


        ATTENZIONE: AGGIORNARE SSID E PASSWORD PER ACCEDERE AL ROUTER.
                    DHCP DISABILITATO: IP ADDRESS IN MANUALE: 192.168.1.104

       NOTA: 1) AT*SIPSERVER=1,80 la porta 80  di default e non  necessario digitarlo dopo 
                l'indirizzo nel browser.
                In tutti gli altri casi  necessario segnalare il numero di porta altrimenti
                non  possibile stabilire il collegamento (es. porta: 8080 => 192.168.9.2:8080).

                 Web Server V.2.0


       #include "WiFI3_Routines.c"
*/
 // ---  ADDRESS E PW FOR MY ROUTER
 const char SSID_STA[]        = "xxxxxxxxxxxxxxxx";   //  your network
 const char password_STA[]    = "xxxxxxxxxxxxxx";     // your password
 const char IP_ADDR_SERVER[]  = "192.168.1.104";
// -----------------------------------------------------------------------------
 const char AT_CIPAP[]        = "CIPAP=";     // Set IP address soft AP
// const char port8080[]        = "8080";
 const char port80[]          = "80";
 const char SSID_AP[]         = "JUMBO elettronica";  //
 const char password_AP[]     = "jumbo123";
 const char IP_address[]      = "192.168.4.1";
 const char AT[]              = "AT+"; // startupTest AT startup
 const char ATE0[]            = "ATE0";//Disable echo
 const char AT_RST[]          = "RST";//Restart module
 const char AT_CWMODE[]       = "CWMODE=2";//WIFI mode (station/softAP/station+softAP) now choice softAP
 const char AT_CWMODE_2[]     = "CWMODE_CUR=";
 const char AT_CIPMUX[]       = "CIPMUX=1";//Set singola connections mode   >1<
 const char AT_CIFSR[]        = "CIFSR";//Get local IP address
 const char AT_CWJAP[]        = "CWJAP_CUR=";// Connect to AP.
 const char AT_CWSAP[]        = "CWSAP=";//Set parameters under AP mode
 const char AT_CWQAP[]        = "CWQAP";//
 const char AT_CIPSTART[]     = "CIPSTART=";//Establish TCP connection or register UDP port
 const char AT_CIPSEND[]      = "CIPSEND=";//Send data
 const char AT_CIPSTATUS[]    ="CIPSTATUS";//Get connection status.
 const char AT_CIPSERVER[]    ="CIPSERVER=1"; // Crea server  <1>
 const char AT_CIPSTO[]       ="CIPSTO=5";   // TIME OUT
 const char AT_CWDHCP[]       ="CWDHCP_CUR=1,0";   //  NO DHCP
 const char AT_CIPSTA[]       ="CIPSTA_CUR=";   //  INDIRIZZO IP MANUALE
 const char AT_RFPOWER[]       ="RFPOWER=";   // Potenza RF (00-82)
 const char AT_SLEEP[]         ="SLEEP=2";   //  Sleep mode 0= disable, 1= soft sleep, 2= modem sleep
 const char AT_GSLP[]         ="GSLP=5000";   // Risveglia il modulo WiFi da SLEEP do il tempo impostato
 const char AT_RFVDD[]         ="RFVDD=3300";   //
 const char AT_GMR[]            = "GMR";
 const char AT_RESTORE[]        = "RESTORE";
 const char AT_CIPSTAMAC[]   = "CIPSTAMAC_DEF=";
 const char MAC[]           = "18:fe:35:98:d3:7b";
//
 const char AT_UDP[]          ="UDP";
 const char AT_TCP[]          ="TCP";           //
 //
 const char ESP_Msg[] =       "JUMBO el";                                     //ESP8266_Msg
//
 const char chanel = 6;
 const char enc = 4;      // Tipo di codifica come A.P. 0 OPEN, 2 WPA_PSK, 3 WPA2_PSK, 4 WPA_WPA2_PSK
 char ESP_id =0;
//  Configure WiFI3-Click module responses to parse
extern const OK;
extern const NO_CHANGE;
extern const READY;
extern char Get_Response();

//sbit LED_Status at RA5_bit;
//
// ---  Prototipe
 void UART_Write_Const(const char *packet);  // Invia pagina web
// *****************************************************************************
//
// *****************************************************************************
 void Delay_msec (unsigned int count_delay) {
      for (count_delay; count_delay > 0; count_delay --) {
         Delay_ms (1) ;
          asm { clrwdt }
        }
 }
// *****************************************************************************  5 lampeggio LED per 1 sec.
// 5 lampeggio LED per 1 sec.
// *****************************************************************************
 void Lampe_LED_Status() {
 unsigned short i;
//
     for (i=1; i<=5; i++) {
       LED_Status = 0;
        Delay_msec(100);
         LED_Status = 1;
          Delay_msec(100);
     }
 }
// *****************************************************************************
//
// *****************************************************************************
 void new_line() {
//
   UART1_Write(0x0D);                //  Carriage return
    UART1_Write(0x0A);               //  Line feed
//
     get_resp_timeout = 0;                               LED=1;
//
      while(Get_Response() != READY && get_resp_timeout <= 100) {   // Time-Out di 10 sec (100)
       /////////////// Lampe_LED_Status();       // 5 lampeggio LED per 1 sec.  // V.2.2 20/05/2017
         Delay_msec(100);                                                       // V.2.2 20/05/2017
          get_resp_timeout ++;
      }
    //    if (get_resp_timeout > 10) flag.ESP_OK = 1;  // Modulo WiFi non inizializzato
 //
      if (responseID == READY) {
        Delay_msec(100);                // 500
      }
      responseID = 0;
      response =0;                                        LED=0;
//
    //  Lampe_LED_Status();            // 5 lampeggio LED per 1 sec.
 }
// *****************************************************************************
//  Send command or data string
// *****************************************************************************
 void esp8266_Send(const char *string_) {
 //
     while(*string_) {
      UART1_Write(*string_++);
     }
 }
// *****************************************************************************
//
// *****************************************************************************
 void WiFi3_Init() {
//
      Delay_msec(100);
     //  Reset = 0;
        Delay_msec(100);
       //  Reset = 1;
          Delay_msec(2000);               // wait five seconds on power-on
           responseID = 0;                                                      // V.2.2 20/05/2017
            response =0;                                                        // V.2.2 20/05/2017
 }
// *****************************************************************************          // CntBatt_18F14K50 V.1.1 23/06/2018
// 0x10 =        SIID (come station) (max 25 caratteri, esclusi simboli tranne '-' e '_')
// 0x30 =        password (come station) (max 25 caratteri, esclusi simboli tranne '-' e '_')
//        ATTENZIONE: SONO AMMESSI SOLO I SIMBOLI '-' '_' '.'
// *****************************************************************************
 void Ref_Send(char addr) {
 char buff = '0';
  unsigned short j = 0;
//
       while (buff != ' ' && j <= 25) {
          buff = EEPROM_Read(addr + j);
// ------------------ 01/09/2018: Aggiunto discriminatorio 0x0A e 0x0D (crea problemi nell'inizializzazione del ESP)
           if (buff == ' ' || buff == 0x0A || buff == 0x0D) return;   // Fine data
            if (buff == 0xFF) buff = '0';  // EEPROM vergine
             UART1_Write(buff);
              j++;
       }
//
 }
// *****************************************************************************
//
// *****************************************************************************
 void IP_ADDR_Send() {
//
  /*    Word_to_string(IP_ADDR_1);
   //   Word_to_string(EEPROM_Read(0x08));
       UART1_Write('.');
        Word_to_string(IP_ADDR_2);
    //    Word_to_string(EEPROM_Read(0x09));
         UART1_Write('.');
          Word_to_string(IP_ADDR_3);
       //   Word_to_string(EEPROM_Read(0x0A));
           UART1_Write('.');
            Word_to_string(IP_ADDR_4);
        //    Word_to_string(EEPROM_Read(0x0B));
    */
 }
// *****************************************************************************
//
// *****************************************************************************
 void WiFi3_CWMODE() {
//
     esp8266_Send (AT);
      esp8266_Send (AT_CWMODE_2);
       if (flag_.soft_AP) UART1_Write('2');
        else UART1_Write('1');
         new_line();                                         // V.2.2 20/05/2017
 }
// *****************************************************************************
//
// *****************************************************************************
 void WiFI_Configure() {
//
  /*  LED_Status = 1;                  // restore
     esp8266_Send (AT);
      esp8266_Send (AT_RESTORE);
       new_line();   */
//
 
//
    LED_Status = 1;                  // 1  RESET
     esp8266_Send (AT);
      esp8266_Send (AT_RST);
       new_line(); 
        LED_Status = 0;
         Delay_msec(2000);

//
// ---  Disconnetti dal router
    //LED_Status = 1;                   //
  /*   esp8266_Send (AT);
      esp8266_Send (AT_CWQAP);
       new_line();
     esp8266_Send (AT);
      esp8266_Send (AT_CWQAP);
       new_line(); */
//
// ---
    LED_Status = 1;                   // 2 CWMODE
     esp8266_Send (AT);
      esp8266_Send (AT_CWMODE);         // Acces Point
       LED_Status = 0;
        new_line();
     //  WiFi3_CWMODE();
//
// ---
    LED_Status = 1;                   // 3  Connessione multipla  CIPMUX
     esp8266_Send (AT);
      esp8266_Send (AT_CIPMUX);
       LED_Status = 0;
        new_line();
//
// ---   CREA SERVER
//                                        AT+CIPSERVER=1,"port" <CR><LF>
    LED_Status = 1;
     esp8266_Send (AT);
      esp8266_Send (AT_CIPSERVER);
       UART1_Write(',');
        esp8266_Send (port80);
         LED_Status = 0;
          new_line();
//

// ---   connected with your network
//                                    AT+CWJAP="SSID","password" <CR><LF>
  /*  esp8266_Send (AT);
      esp8266_Send (AT_CWJAP);
       UART1_Write('"');
        Ref_Send (0x10);                                                           // CntBatt_18F14K50 V.1.1 23/06/2018
         UART1_Write('"');
          UART1_Write(',');
           UART1_Write('"');
            Ref_Send (0x30);                                                       // CntBatt_18F14K50 V.1.1 23/06/2018
             UART1_Write('"');
              new_line();
       */
//
// ---  DHCP  disabilitata e IP ADDR  imposto in manuale
  //  LED_Status = 1;                   //
   /*  esp8266_Send (AT);
      esp8266_Send (AT_CWDHCP);
       new_line();  */
//
// ---   INDIRIZZO IP MANUALE
   //  LED_Status = 1;                  // 4
  /*   esp8266_Send (AT);
      esp8266_Send (AT_CIPSTA);
       UART1_Write('"');
      //  esp8266_Send (IP_ADDR_SERVER);
        IP_ADDR_Send();
         UART1_Write('"');
          new_line();
    */
  //******************************************************
 // ---  set parameter for access point
     //AT+CWSAP="SSID","pasword" , port,port,mode, <CR><LF>
    LED_Status = 1;
    esp8266_Send (AT);                  // 5
     esp8266_Send(AT_CWSAP);
      UART1_Write('"');
       esp8266_Send(SSID_AP);
        UART1_Write('"');
         UART1_Write(',');
          UART1_Write('"');
           esp8266_Send(password_AP);
            UART1_Write('"');
             UART1_Write(',');
              UART1_Write(chanel+48);
               UART1_Write(',');
                UART1_Write(enc+48);   // se "enc" = 0: non  richiesta nessuna password!
                 LED_Status = 0;
                  new_line();
 // ---
    LED_Status = 1;                   // Set IP soft AP
     esp8266_Send (AT);
      esp8266_Send (AT_CIPAP);
       UART1_Write('"');
        esp8266_Send(IP_address);
         UART1_Write('"');
          LED_Status = 0;
           new_line();
//
    //***************************************************
//
// ---  TIMEOUT
    LED_Status = 1;                   //
     esp8266_Send (AT);
      esp8266_Send (AT_CIPSTO);
       LED_Status = 0;
        new_line();
//
// --- SLEEP MODE
   /*
    esp8266_Send (AT);
      esp8266_Send (AT_SLEEP);         // SLEEP mode type
       new_line();
    */
//
  //
  /*  LED_Status = 1;                  // CONFIGURATION ESP8266
     esp8266_Send (AT);
      esp8266_Send (AT_GMR);
       new_line();         */
//
// ---
  //  Lampe_LED_Status();            // 5 lampeggio LED per 1 sec.
  //   Lampe_LED_Status();           // 5 lampeggio LED per 1 sec.
 }
 
/*


*/