/*
        CONFIGURAZIONE PIC18F14K50 e PIC18F14K22



*/
//
//******************************************************************************
// Initialization Routine
//******************************************************************************
 void Init_PIC() {
// --- Oscillatore
  OSCCON =  0b01111000;          // 16 MHz,
  OSCCON2 = 0b00000100;
  OSCTUNE.B6 = 1;              // PLL ON
 // T1CON.T1OSCEN = 1;
// --- Analog
  ANSEL =  0b00000000;          // RC3, RC2, RC1, RC0, RA4, RA2, RA1, RA0
  ANSELH = 0b00000011;         // ---, ---, ---, ---, RB5, RB4, RC7, RC6
// --- Comparator
  CM1CON0 = 0x00;
  CM2CON0 = 0x00;
// --- T1
  T1CON = 0;
// --- T3
  T3CON = 0;
// --- PORT A    NOTA per PIC18F14K50: RA0= D+, RA1= D-, RA4 e RA5= Oscillatore, RA2= condensatore.
  PORTA = 0 ;                   // Esistenti bit: --XX.XXXX
  TRISA = 0b11111111;          // set PORTA
  WPUB =  0b11111111;
// --- PORT B
  PORTB = 0 ;                   // Esistenti bit: XXXX.----
  TRISB = 0b00100000;          // set PORTB
  WPUB =  0b11110000;
// --- PORT C
  TRISC = 0b11000000;           // Esistenti bit: XXXX.XXXX
  PORTC = 0 ;                   // Set PORTC
  LATC = 0;
// --- Enable Pull-up
  INTCON2.RABPU = 0;           // Enable pull-up PORTA e PORTB
//  --- UART1
  UART1_Init(115200);  // 9600 (OK)  19200 (OK)  38400 (OK) 57600 (OK) 115200 (OK)
//  --- T0
  //  T0CON = 0b11000000;        // T0 ON, 8 bit, pres 1/2.
// ---

 }
//******************************************************************************
 void Init_Interrupt () {
        // ------------------------------------- TMR1
 // T1CON = 0b00110001;        // Abilita il TMR1,
 // TMR1H = 0x0B;
 // TMR1L = 0xDC;
  //--------------------------------------
  //  interrupts
  //--------------------------------------
//        INTCON = 0;                  // Disable GIE, PEIE, TMR0IE,INT0IE,RBIE
    ///    PIR1.TMR1IF = 0;
    ///    PIE1.TMR1IE = 1;            // Abilita l'overflow di TMR1
  PIR1.RCIF = 0;
  PIE1.RCIE = 1;
//
  INTCON = 0b11000000 ;        // Abilita interrupt
  
 }

// *****************************************************************************